/**
 * link-local-dependencies
 * Install local lerna dependencies
 */
import * as TE from 'fp-ts/TaskEither';
import { PackageManifestsError } from '@typescript-tools/package-manifests';
import { LernaPackage } from '@typescript-tools/io-ts/dist/lib/LernaPackage';
export declare type LinkLocalDependenciesError = PackageManifestsError | {
    type: 'unknown package';
    package: string;
} | {
    type: 'unable to decode package manifest';
    error: string;
} | {
    type: 'unable to create directory';
    path: string;
    error: Error;
} | {
    type: 'unable to create symlink';
    target: string;
    path: string;
    error: Error;
};
export declare const linkLocalDependencies: (packages: Map<string, LernaPackage>) => (packagePathOrName: string) => TE.TaskEither<LinkLocalDependenciesError, void>;
export declare const linkAllLocalDependencies: (packagesList: LernaPackage[], packagesMap: Map<string, LernaPackage>) => TE.TaskEither<LinkLocalDependenciesError, void>;
//# sourceMappingURL=index.d.ts.map