#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const t = __importStar(require("io-ts"));
const A = __importStar(require("fp-ts/ReadonlyArray"));
const E = __importStar(require("fp-ts/Either"));
const M = __importStar(require("fp-ts/Map"));
const T = __importStar(require("fp-ts/Task"));
const TE = __importStar(require("fp-ts/TaskEither"));
const IO = __importStar(require("fp-ts/IO"));
const Console = __importStar(require("fp-ts/Console"));
const PathReporter = __importStar(require("io-ts/lib/PathReporter"));
const function_1 = require("fp-ts/lib/function");
const io_ts_docopt_1 = require("io-ts-docopt");
const lerna_packages_1 = require("@typescript-tools/lerna-packages");
const index_1 = require("./index");
const Eq_1 = require("fp-ts/Eq");
const Semigroup_1 = require("fp-ts/Semigroup");
const docstring = `
Usage:
    link-local-dependencies [<package>]

Options:
    package    Path or name of single package for which to install local dependencies
`;
const CommandLineOptions = io_ts_docopt_1.withEncode(t.type({
    '<package>': t.union([t.null, t.string]),
}), a => ({
    pkg: a['<package>'],
}));
const err = function_1.identity;
const decodeDocopt = function_1.flow(io_ts_docopt_1.decodeDocopt, E.mapLeft(function_1.flow(errors => PathReporter.failure(errors).join('\n'), error => err({ type: 'docopt decode', error }))), TE.fromEither);
const lernaPackages = function_1.flow(lerna_packages_1.lernaPackages, TE.bimap(err, packages => function_1.pipe(packages, A.chain((pkg) => [
    [pkg.name, pkg],
    [pkg.location, pkg],
]), M.fromFoldable(Eq_1.eqString, Semigroup_1.getFirstSemigroup(), A.readonlyArray), packagesMap => ({ list: packages, map: packagesMap }))));
const linkLocalDependencies = (packages) => function_1.flow(index_1.linkLocalDependencies(packages), TE.mapLeft(err));
const linkAllLocalDependencies = function_1.flow(index_1.linkAllLocalDependencies, TE.mapLeft(err));
const exit = (code) => () => process.exit(code);
const main = function_1.pipe(TE.bindTo('options')(decodeDocopt(CommandLineOptions, docstring)), 
// FIXME: process.cwd should instead be exposed as a parameter
TE.bind('packages', () => lernaPackages(process.cwd())), TE.chain(({ options, packages }) => options.pkg
    ? linkLocalDependencies(packages.map)(options.pkg)
    : linkAllLocalDependencies(packages.list, packages.map)), TE.getOrElseW(function_1.flow(Console.error, IO.chain(() => exit(1)), T.fromIO)));
main();
// Local Variables:
// mode: typescript
// End:
//# sourceMappingURL=link-local-dependencies.js.map